/// \file
/// \author Diffblue Ltd.
/// Adds an instrumentation to add initialisations for variables
/// used by the --malloc-may-fail and related flags in cbmc

// NOLINT(whitespace/line_length)
#ifndef CPROVER_GOTO_PROGRAMS_ADD_MALLOC_MAY_FAIL_VARIABLE_INITIALIZATIONS_H
// NOLINT(whitespace/line_length)
#define CPROVER_GOTO_PROGRAMS_ADD_MALLOC_MAY_FAIL_VARIABLE_INITIALIZATIONS_H

class goto_modelt;

/// Some variables have different initial values based on what flags are being
/// passed to cbmc; since the _start function might've been generated by goto-cc
/// before getting passed over here we need to add the initialisation of these
/// variables here as a post-processing step
void add_malloc_may_fail_variable_initializations(goto_modelt &goto_model);

// NOLINT(whitespace/line_length)
#endif // CPROVER_GOTO_PROGRAMS_ADD_MALLOC_MAY_FAIL_VARIABLE_INITIALIZATIONS_H
